Package com.ngrok.services

# Class EdgesHttpsRoutes.CreateCallBuilder

java.lang.Object
com.ngrok.services.EdgesHttpsRoutes.CreateCallBuilder

Enclosing class:
  EdgesHttpsRoutes

public class EdgesHttpsRoutes.CreateCallBuilder extends Object
A builder object encapsulating state for an unsent Create API call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `EdgesHttpsRoutes.CreateCallBuilder`
  `backend(EndpointBackendMutate backend)`
  backend module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `backend(Optional<EndpointBackendMutate> backend)`
  backend module configuration or `null`
  `HttpsEdgeRoute`
  `blockingCall()`
  Initiates the API call and blocks until it returns.
  `CompletionStage<HttpsEdgeRoute>`
  `call()`
  Initiates the API call asynchronously.
  `EdgesHttpsRoutes.CreateCallBuilder`
  `circuitBreaker(EndpointCircuitBreaker circuitBreaker)`
  circuit breaker module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `circuitBreaker(Optional<EndpointCircuitBreaker> circuitBreaker)`
  circuit breaker module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `compression(EndpointCompression compression)`
  compression module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `compression(Optional<EndpointCompression> compression)`
  compression module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `description(String description)`
  human-readable description of what this edge will be used for; optional, max 255 bytes.
  `EdgesHttpsRoutes.CreateCallBuilder`
  `description(Optional<String> description)`
  human-readable description of what this edge will be used for; optional, max 255 bytes.
  `EdgesHttpsRoutes.CreateCallBuilder`
  `ipRestriction(EndpointIpPolicyMutate ipRestriction)`
  ip restriction module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `ipRestriction(Optional<EndpointIpPolicyMutate> ipRestriction)`
  ip restriction module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `metadata(String metadata)`
  arbitrary user-defined machine-readable data of this edge.
  `EdgesHttpsRoutes.CreateCallBuilder`
  `metadata(Optional<String> metadata)`
  arbitrary user-defined machine-readable data of this edge.
  `EdgesHttpsRoutes.CreateCallBuilder`
  `oauth(EndpointOAuth oauth)`
  oauth module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `oauth(Optional<EndpointOAuth> oauth)`
  oauth module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `oidc(EndpointOidc oidc)`
  oidc module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `oidc(Optional<EndpointOidc> oidc)`
  oidc module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `requestHeaders(EndpointRequestHeaders requestHeaders)`
  request headers module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `requestHeaders(Optional<EndpointRequestHeaders> requestHeaders)`
  request headers module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `responseHeaders(EndpointResponseHeaders responseHeaders)`
  response headers module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `responseHeaders(Optional<EndpointResponseHeaders> responseHeaders)`
  response headers module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `saml(EndpointSamlMutate saml)`
  saml module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `saml(Optional<EndpointSamlMutate> saml)`
  saml module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `webhookVerification(EndpointWebhookValidation webhookVerification)`
  webhook verification module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `webhookVerification(Optional<EndpointWebhookValidation> webhookVerification)`
  webhook verification module configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `websocketTcpConverter(EndpointWebsocketTcpConverter websocketTcpConverter)`
  websocket to tcp adapter configuration or `null`
  `EdgesHttpsRoutes.CreateCallBuilder`
  `websocketTcpConverter(Optional<EndpointWebsocketTcpConverter> websocketTcpConverter)`
  websocket to tcp adapter configuration or `null`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### description

    public EdgesHttpsRoutes.CreateCallBuilder description(String description)
    human-readable description of what this edge will be used for; optional, max 255 bytes.
    Parameters:
      `description` - the value of the description parameter as a `String`
    Returns:
      the call builder instance

  - ### description

    public EdgesHttpsRoutes.CreateCallBuilder description(Optional<String> description)
    human-readable description of what this edge will be used for; optional, max 255 bytes.
    Parameters:
      `description` - the value of the description parameter as an `Optional` of `String`
    Returns:
      the call builder instance

  - ### metadata

    public EdgesHttpsRoutes.CreateCallBuilder metadata(String metadata)
    arbitrary user-defined machine-readable data of this edge. Optional, max 4096 bytes.
    Parameters:
      `metadata` - the value of the metadata parameter as a `String`
    Returns:
      the call builder instance

  - ### metadata

    public EdgesHttpsRoutes.CreateCallBuilder metadata(Optional<String> metadata)
    arbitrary user-defined machine-readable data of this edge. Optional, max 4096 bytes.
    Parameters:
      `metadata` - the value of the metadata parameter as an `Optional` of `String`
    Returns:
      the call builder instance

  - ### backend

    public EdgesHttpsRoutes.CreateCallBuilder backend(EndpointBackendMutate backend)
    backend module configuration or `null`
    Parameters:
      `backend` - the value of the backend parameter as a `EndpointBackendMutate`
    Returns:
      the call builder instance

  - ### backend

    public EdgesHttpsRoutes.CreateCallBuilder backend(Optional<EndpointBackendMutate> backend)
    backend module configuration or `null`
    Parameters:
      `backend` - the value of the backend parameter as an `Optional` of `EndpointBackendMutate`
    Returns:
      the call builder instance

  - ### ipRestriction

    public EdgesHttpsRoutes.CreateCallBuilder ipRestriction(EndpointIpPolicyMutate ipRestriction)
    ip restriction module configuration or `null`
    Parameters:
      `ipRestriction` - the value of the ip_restriction parameter as a `EndpointIpPolicyMutate`
    Returns:
      the call builder instance

  - ### ipRestriction

    public EdgesHttpsRoutes.CreateCallBuilder ipRestriction(Optional<EndpointIpPolicyMutate> ipRestriction)
    ip restriction module configuration or `null`
    Parameters:
      `ipRestriction` - the value of the ip_restriction parameter as an `Optional` of `EndpointIpPolicyMutate`
    Returns:
      the call builder instance

  - ### circuitBreaker

    public EdgesHttpsRoutes.CreateCallBuilder circuitBreaker(EndpointCircuitBreaker circuitBreaker)
    circuit breaker module configuration or `null`
    Parameters:
      `circuitBreaker` - the value of the circuit_breaker parameter as a `EndpointCircuitBreaker`
    Returns:
      the call builder instance

  - ### circuitBreaker

    public EdgesHttpsRoutes.CreateCallBuilder circuitBreaker(Optional<EndpointCircuitBreaker> circuitBreaker)
    circuit breaker module configuration or `null`
    Parameters:
      `circuitBreaker` - the value of the circuit_breaker parameter as an `Optional` of `EndpointCircuitBreaker`
    Returns:
      the call builder instance

  - ### compression

    public EdgesHttpsRoutes.CreateCallBuilder compression(EndpointCompression compression)
    compression module configuration or `null`
    Parameters:
      `compression` - the value of the compression parameter as a `EndpointCompression`
    Returns:
      the call builder instance

  - ### compression

    public EdgesHttpsRoutes.CreateCallBuilder compression(Optional<EndpointCompression> compression)
    compression module configuration or `null`
    Parameters:
      `compression` - the value of the compression parameter as an `Optional` of `EndpointCompression`
    Returns:
      the call builder instance

  - ### requestHeaders

    public EdgesHttpsRoutes.CreateCallBuilder requestHeaders(EndpointRequestHeaders requestHeaders)
    request headers module configuration or `null`
    Parameters:
      `requestHeaders` - the value of the request_headers parameter as a `EndpointRequestHeaders`
    Returns:
      the call builder instance

  - ### requestHeaders

    public EdgesHttpsRoutes.CreateCallBuilder requestHeaders(Optional<EndpointRequestHeaders> requestHeaders)
    request headers module configuration or `null`
    Parameters:
      `requestHeaders` - the value of the request_headers parameter as an `Optional` of `EndpointRequestHeaders`
    Returns:
      the call builder instance

  - ### responseHeaders

    public EdgesHttpsRoutes.CreateCallBuilder responseHeaders(EndpointResponseHeaders responseHeaders)
    response headers module configuration or `null`
    Parameters:
      `responseHeaders` - the value of the response_headers parameter as a `EndpointResponseHeaders`
    Returns:
      the call builder instance

  - ### responseHeaders

    public EdgesHttpsRoutes.CreateCallBuilder responseHeaders(Optional<EndpointResponseHeaders> responseHeaders)
    response headers module configuration or `null`
    Parameters:
      `responseHeaders` - the value of the response_headers parameter as an `Optional` of `EndpointResponseHeaders`
    Returns:
      the call builder instance

  - ### webhookVerification

    public EdgesHttpsRoutes.CreateCallBuilder webhookVerification(EndpointWebhookValidation webhookVerification)
    webhook verification module configuration or `null`
    Parameters:
      `webhookVerification` - the value of the webhook_verification parameter as a `EndpointWebhookValidation`
    Returns:
      the call builder instance

  - ### webhookVerification

    public EdgesHttpsRoutes.CreateCallBuilder webhookVerification(Optional<EndpointWebhookValidation> webhookVerification)
    webhook verification module configuration or `null`
    Parameters:
      `webhookVerification` - the value of the webhook_verification parameter as an `Optional` of `EndpointWebhookValidation`
    Returns:
      the call builder instance

  - ### oauth

    public EdgesHttpsRoutes.CreateCallBuilder oauth(EndpointOAuth oauth)
    oauth module configuration or `null`
    Parameters:
      `oauth` - the value of the oauth parameter as a `EndpointOAuth`
    Returns:
      the call builder instance

  - ### oauth

    public EdgesHttpsRoutes.CreateCallBuilder oauth(Optional<EndpointOAuth> oauth)
    oauth module configuration or `null`
    Parameters:
      `oauth` - the value of the oauth parameter as an `Optional` of `EndpointOAuth`
    Returns:
      the call builder instance

  - ### saml

    public EdgesHttpsRoutes.CreateCallBuilder saml(EndpointSamlMutate saml)
    saml module configuration or `null`
    Parameters:
      `saml` - the value of the saml parameter as a `EndpointSamlMutate`
    Returns:
      the call builder instance

  - ### saml

    public EdgesHttpsRoutes.CreateCallBuilder saml(Optional<EndpointSamlMutate> saml)
    saml module configuration or `null`
    Parameters:
      `saml` - the value of the saml parameter as an `Optional` of `EndpointSamlMutate`
    Returns:
      the call builder instance

  - ### oidc

    public EdgesHttpsRoutes.CreateCallBuilder oidc(EndpointOidc oidc)
    oidc module configuration or `null`
    Parameters:
      `oidc` - the value of the oidc parameter as a `EndpointOidc`
    Returns:
      the call builder instance

  - ### oidc

    public EdgesHttpsRoutes.CreateCallBuilder oidc(Optional<EndpointOidc> oidc)
    oidc module configuration or `null`
    Parameters:
      `oidc` - the value of the oidc parameter as an `Optional` of `EndpointOidc`
    Returns:
      the call builder instance

  - ### websocketTcpConverter

    public EdgesHttpsRoutes.CreateCallBuilder websocketTcpConverter(EndpointWebsocketTcpConverter websocketTcpConverter)
    websocket to tcp adapter configuration or `null`
    Parameters:
      `websocketTcpConverter` - the value of the websocket_tcp_converter parameter as a `EndpointWebsocketTcpConverter`
    Returns:
      the call builder instance

  - ### websocketTcpConverter

    public EdgesHttpsRoutes.CreateCallBuilder websocketTcpConverter(Optional<EndpointWebsocketTcpConverter> websocketTcpConverter)
    websocket to tcp adapter configuration or `null`
    Parameters:
      `websocketTcpConverter` - the value of the websocket_tcp_converter parameter as an `Optional` of `EndpointWebsocketTcpConverter`
    Returns:
      the call builder instance

  - ### call

    public CompletionStage<HttpsEdgeRoute> call()
    Initiates the API call asynchronously.
    Returns:
      a `CompletionStage` of `HttpsEdgeRoute`

  - ### blockingCall

    public HttpsEdgeRoute blockingCall() throws InterruptedException
    Initiates the API call and blocks until it returns.
    Returns:
      `HttpsEdgeRoute`
    Throws:
      `InterruptedException` - if the thread was interrupted during the call